Package org.jboss.resteasy.client.jaxrs.internal

## Class ResteasyClientImpl

- java.lang.Object
- - org.jboss.resteasy.client.jaxrs.internal.ResteasyClientImpl

- All Implemented Interfaces:
    `javax.ws.rs.client.Client`, `javax.ws.rs.core.Configurable<javax.ws.rs.client.Client>`, `ResteasyClient`

      public class ResteasyClientImpl
      extends Object
      implements ResteasyClient

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected boolean` | `cleanupExecutor` |
    `protected boolean` | `closed` |
    `protected ClientConfiguration` | `configuration` |
    `protected ClientHttpEngine` | `httpEngine` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `ResteasyClientImpl​(ClientHttpEngine httpEngine, ExecutorService asyncInvocationExecutor, boolean cleanupExecutor, ScheduledExecutorService scheduledExecutorService, ClientConfiguration configuration)` |
    `protected` | `ResteasyClientImpl​(ClientHttpEngine httpEngine, ExecutorService asyncInvocationExecutor, boolean cleanupExecutor, ClientConfiguration configuration)` |
    `protected` | `ResteasyClientImpl​(ClientHttpEngine httpEngine, ExecutorService asyncInvocationExecutor, boolean cleanupExecutor, ContextualScheduledExecutorService scheduledExecutorService, ClientConfiguration configuration)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `abortIfClosed()` |
    `ExecutorService` | `asyncInvocationExecutor()` |
    `void` | `close()` |
    `protected ResteasyWebTarget` | `createClientWebTarget​(ResteasyClientImpl client, String uri, ClientConfiguration configuration)` |
    `protected ResteasyWebTarget` | `createClientWebTarget​(ResteasyClientImpl client, URI uri, ClientConfiguration configuration)` |
    `protected ResteasyWebTarget` | `createClientWebTarget​(ResteasyClientImpl client, javax.ws.rs.core.UriBuilder uriBuilder, ClientConfiguration configuration)` |
    `javax.ws.rs.core.Configuration` | `getConfiguration()` |
    `HostnameVerifier` | `getHostnameVerifier()` |
    `ScheduledExecutorService` | `getScheduledExecutor()` |
    `SSLContext` | `getSslContext()` |
    `ClientHttpEngine` | `httpEngine()` |
    `javax.ws.rs.client.Invocation.Builder` | `invocation​(javax.ws.rs.core.Link link)` |
    `boolean` | `isClosed()` |
    `ResteasyClientImpl` | `property​(String name, Object value)` |
    `ResteasyClientImpl` | `register​(Class<?> componentClass)` |
    `ResteasyClientImpl` | `register​(Class<?> componentClass, int priority)` |
    `ResteasyClientImpl` | `register​(Class<?> componentClass, Class<?>... contracts)` |
    `ResteasyClientImpl` | `register​(Class<?> componentClass, Map<Class<?>,​Integer> contracts)` |
    `ResteasyClientImpl` | `register​(Object component)` |
    `ResteasyClientImpl` | `register​(Object component, int priority)` |
    `ResteasyClientImpl` | `register​(Object component, Class<?>... contracts)` |
    `ResteasyClientImpl` | `register​(Object component, Map<Class<?>,​Integer> contracts)` |
    `ResteasyWebTarget` | `target​(String uri)` |
    `ResteasyWebTarget` | `target​(URI uri)` |
    `ResteasyWebTarget` | `target​(javax.ws.rs.core.Link link)` |
    `ResteasyWebTarget` | `target​(javax.ws.rs.core.UriBuilder uriBuilder)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### httpEngine

          protected final ClientHttpEngine httpEngine

    - #### configuration

          protected ClientConfiguration configuration

    - #### closed

          protected boolean closed

    - #### cleanupExecutor

          protected boolean cleanupExecutor

  - ### Constructor Detail

    - #### ResteasyClientImpl

          protected ResteasyClientImpl​(ClientHttpEngine httpEngine,
                                       ExecutorService asyncInvocationExecutor,
                                       boolean cleanupExecutor,
                                       ScheduledExecutorService scheduledExecutorService,
                                       ClientConfiguration configuration)

    - #### ResteasyClientImpl

          protected ResteasyClientImpl​(ClientHttpEngine httpEngine,
                                       ExecutorService asyncInvocationExecutor,
                                       boolean cleanupExecutor,
                                       ContextualScheduledExecutorService scheduledExecutorService,
                                       ClientConfiguration configuration)

    - #### ResteasyClientImpl

          protected ResteasyClientImpl​(ClientHttpEngine httpEngine,
                                       ExecutorService asyncInvocationExecutor,
                                       boolean cleanupExecutor,
                                       ClientConfiguration configuration)

  - ### Method Detail

    - #### httpEngine

          public ClientHttpEngine httpEngine()

      Specified by:
        `httpEngine` in interface `ResteasyClient`

    - #### asyncInvocationExecutor

          public ExecutorService asyncInvocationExecutor()

      Specified by:
        `asyncInvocationExecutor` in interface `ResteasyClient`

    - #### getScheduledExecutor

          public ScheduledExecutorService getScheduledExecutor()

      Specified by:
        `getScheduledExecutor` in interface `ResteasyClient`

    - #### abortIfClosed

          public void abortIfClosed()

      Specified by:
        `abortIfClosed` in interface `ResteasyClient`

    - #### isClosed

          public boolean isClosed()

      Specified by:
        `isClosed` in interface `ResteasyClient`

    - #### close

          public void close()

      Specified by:
        `close` in interface `javax.ws.rs.client.Client`

    - #### getConfiguration

          public javax.ws.rs.core.Configuration getConfiguration()

      Specified by:
        `getConfiguration` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.Client>`

    - #### getSslContext

          public SSLContext getSslContext()

      Specified by:
        `getSslContext` in interface `javax.ws.rs.client.Client`

    - #### getHostnameVerifier

          public HostnameVerifier getHostnameVerifier()

      Specified by:
        `getHostnameVerifier` in interface `javax.ws.rs.client.Client`

    - #### property

          public ResteasyClientImpl property​(String name,
                                             Object value)

      Specified by:
        `property` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.Client>`

    - #### register

          public ResteasyClientImpl register​(Class<?> componentClass)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.Client>`

    - #### register

          public ResteasyClientImpl register​(Class<?> componentClass,
                                             int priority)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.Client>`

    - #### register

          public ResteasyClientImpl register​(Class<?> componentClass,
                                             Class<?>... contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.Client>`

    - #### register

          public ResteasyClientImpl register​(Class<?> componentClass,
                                             Map<Class<?>,​Integer> contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.Client>`

    - #### register

          public ResteasyClientImpl register​(Object component)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.Client>`

    - #### register

          public ResteasyClientImpl register​(Object component,
                                             int priority)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.Client>`

    - #### register

          public ResteasyClientImpl register​(Object component,
                                             Class<?>... contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.Client>`

    - #### register

          public ResteasyClientImpl register​(Object component,
                                             Map<Class<?>,​Integer> contracts)

      Specified by:
        `register` in interface `javax.ws.rs.core.Configurable<javax.ws.rs.client.Client>`

    - #### target

          public ResteasyWebTarget target​(String uri)
                                   throws IllegalArgumentException,
                                          NullPointerException

      Specified by:
        `target` in interface `javax.ws.rs.client.Client`
      Specified by:
        `target` in interface `ResteasyClient`
      Throws:
        `IllegalArgumentException`
        `NullPointerException`

    - #### target

          public ResteasyWebTarget target​(URI uri)
                                   throws NullPointerException

      Specified by:
        `target` in interface `javax.ws.rs.client.Client`
      Specified by:
        `target` in interface `ResteasyClient`
      Throws:
        `NullPointerException`

    - #### target

          public ResteasyWebTarget target​(javax.ws.rs.core.UriBuilder uriBuilder)
                                   throws NullPointerException

      Specified by:
        `target` in interface `javax.ws.rs.client.Client`
      Specified by:
        `target` in interface `ResteasyClient`
      Throws:
        `NullPointerException`

    - #### target

          public ResteasyWebTarget target​(javax.ws.rs.core.Link link)
                                   throws NullPointerException

      Specified by:
        `target` in interface `javax.ws.rs.client.Client`
      Specified by:
        `target` in interface `ResteasyClient`
      Throws:
        `NullPointerException`

    - #### invocation

          public javax.ws.rs.client.Invocation.Builder invocation​(javax.ws.rs.core.Link link)
                                                           throws NullPointerException,
                                                                  IllegalArgumentException

      Specified by:
        `invocation` in interface `javax.ws.rs.client.Client`
      Throws:
        `NullPointerException`
        `IllegalArgumentException`

    - #### createClientWebTarget

          protected ResteasyWebTarget createClientWebTarget​(ResteasyClientImpl client,
                                                            String uri,
                                                            ClientConfiguration configuration)

    - #### createClientWebTarget

          protected ResteasyWebTarget createClientWebTarget​(ResteasyClientImpl client,
                                                            URI uri,
                                                            ClientConfiguration configuration)

    - #### createClientWebTarget

          protected ResteasyWebTarget createClientWebTarget​(ResteasyClientImpl client,
                                                            javax.ws.rs.core.UriBuilder uriBuilder,
                                                            ClientConfiguration configuration)